SystemOrganization addCategory: #'Koans-Abouts'!
SystemOrganization addCategory: #'Koans-Bonsai'!
SystemOrganization addCategory: #'Koans-Core'!
SystemOrganization addCategory: #'Koans-SUnit'!

PluggableWidgetSpec subclass: #KoanProgressSpec
	instanceVariableNames: 'progressAccessor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Koans-Core'!

!KoanProgressSpec methodsFor: 'building' stamp: 'esec 10/10/2011 15:22'!
buildWith: aBuilder
	| aMorph |
	aMorph := KoanProgressMorph new.
	aMorph
		model: self model;
		progressAccessor: self progressAccessor.
	aBuilder setFrame: self frame in: aMorph.
	aBuilder parent ifNotNil: [ aBuilder add: aMorph to: aBuilder parent ].
	aMorph updateProgress! !

!KoanProgressSpec methodsFor: 'accessing' stamp: 'esec 10/10/2011 15:23'!
progressAccessor
	^ progressAccessor! !

!KoanProgressSpec methodsFor: 'accessing' stamp: 'esec 10/10/2011 15:23'!
progressAccessor: anObject
	progressAccessor := anObject! !

Exception subclass: #KoanCaseFailedException
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Koans-Core'!

TestResult subclass: #KoanTestResult
	instanceVariableNames: 'exceptions'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Koans-SUnit'!

!KoanTestResult methodsFor: 'accessing' stamp: 'topa 10/14/2015 13:35'!
exceptions
	^ exceptions! !

!KoanTestResult methodsFor: 'accessing' stamp: 'topa 10/14/2015 13:35'!
exceptions: anObject
	exceptions := anObject! !

!KoanTestResult methodsFor: 'accessing' stamp: 'topa 10/14/2015 13:38'!
firstException

	^ self exceptions values first! !

!KoanTestResult methodsFor: 'initialization' stamp: 'topa 10/14/2015 13:35'!
initialize 
	super initialize.
	exceptions := Dictionary new.! !

!KoanTestResult methodsFor: 'running' stamp: 'topa 10/14/2015 13:35'!
runCase: aTestCase 
	| testCasePassed |
	testCasePassed := true.
	[[aTestCase runCase]
		on: self class failure
		do: [:ex | 
			failures add: aTestCase.
			self storeException: ex for: aTestCase.
			testCasePassed := false.
			ex return: false]]
		on: self class error
		do: [:ex | 
			errors add: aTestCase.
			self  storeException: ex for: aTestCase.
			testCasePassed := false.
			ex return: false].
	testCasePassed
		ifTrue: [passed add: aTestCase]
! !

!KoanTestResult methodsFor: 'running' stamp: 'topa 10/14/2015 13:37'!
storeException: ex for: aTestCase
	"We have to copy the stack of the signaler context to preserve it
	for future inspection (as the original context will be resumed)"
	| store |
	store := ex copy.
	store searchFrom: ex signalerContext copyStack.
	self exceptions at: aTestCase put: store
! !

PluggablePanelMorph subclass: #KoanProgressMorph
	instanceVariableNames: 'greenMorph redMorph progressAccessor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Koans-Core'!

!KoanProgressMorph methodsFor: 'building' stamp: 'esec 11/1/2011 12:31:38.542'!
createGreenMorph
	^ greenMorph := (GradientFillMorph new)
		color: Color lightCyan;
		gradientFillColor: Color cyan muchDarker;
		beVertical;
		layoutFrame: self greenFrame;
		hResizing: #spaceFill;
		vResizing: #spaceFill;
		yourself! !

!KoanProgressMorph methodsFor: 'building' stamp: 'esec 11/1/2011 12:32:36.341'!
createRedMorph
	^ redMorph := (GradientFillMorph new)
		color: Color lightGray;
		gradientFillColor: Color veryDarkGray;
		beVertical;
		layoutFrame: self redFrame;
		hResizing: #spaceFill;
		vResizing: #spaceFill;
		yourself! !

!KoanProgressMorph methodsFor: 'building' stamp: 'esec 10/10/2011 15:39'!
greenFrame
	^LayoutFrame new
		leftFraction: 0 offset: 0;
		topFraction: 0 offset: 0;
		rightFraction: 0 offset: 0;
		bottomFraction: 1 offset: 0! !

!KoanProgressMorph methodsFor: 'initialize-release' stamp: 'esec 10/10/2011 15:39'!
initialize
	super initialize.
	self
		layoutPolicy: ProportionalLayout new;
		addMorphBack: self createGreenMorph;
		addMorphBack: self createRedMorph! !

!KoanProgressMorph methodsFor: 'accessing' stamp: 'esec 10/10/2011 15:19'!
progress
	^ self model perform: self progressAccessor! !

!KoanProgressMorph methodsFor: 'accessing' stamp: 'esec 11/1/2011 12:24:32.285'!
progress: aFloat
	greenMorph layoutFrame rightFraction: aFloat offset: 0.
	redMorph layoutFrame leftFraction: aFloat offset: 0.
	self layoutChanged! !

!KoanProgressMorph methodsFor: 'accessing' stamp: 'esec 10/10/2011 15:20'!
progressAccessor
	^ progressAccessor! !

!KoanProgressMorph methodsFor: 'accessing' stamp: 'esec 10/10/2011 15:20'!
progressAccessor: anObject
	progressAccessor := anObject! !

!KoanProgressMorph methodsFor: 'building' stamp: 'esec 10/10/2011 15:39'!
redFrame
	^LayoutFrame new
		leftFraction: 0 offset: 0;
		topFraction: 0 offset: 0;
		rightFraction: 1 offset: 0;
		bottomFraction: 1 offset: 0! !

!KoanProgressMorph methodsFor: 'update' stamp: 'esec 11/1/2011 12:23:25.38'!
update: aParameter
	#progress = aParameter
		ifTrue: [ self progress: self progress ].
	super update: aParameter! !

!KoanProgressMorph methodsFor: 'update' stamp: 'esec 10/10/2011 15:21'!
updateProgress
	self update: #progess! !

TestCase subclass: #KoanCase
	instanceVariableNames: 'xx'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Koans-Core'!

KoanCase subclass: #KoanAboutAsserts
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Koans-Abouts'!

!KoanAboutAsserts class methodsFor: 'accessing' stamp: 'esec 10/10/2011 16:52'!
priority
	^ 0! !

!KoanAboutAsserts methodsFor: 'tests' stamp: 'rms 11/7/2011 19:40'!
test01assertTruth
	"We shall contemplate truth by testing reality, via asserts."

	self assert: false	"This should be true"! !

!KoanAboutAsserts methodsFor: 'tests' stamp: 'rms 11/7/2011 19:40'!
test02assertWithDescription
	"Enlightenment may be more easily achieved with appropriate messages."

	self assert: false description: 'This should be true -- Please fix this'! !

!KoanAboutAsserts methodsFor: 'tests' stamp: 'esec 10/21/2011 17:45:20.693'!
test03assertReality
	"To understand reality, we must compare our expectations against reality."

	| expectedValue actualValue |
	expectedValue := xx.
	actualValue := 1 + 1.
	self assert: expectedValue = actualValue! !

!KoanAboutAsserts methodsFor: 'tests' stamp: 'esec 10/18/2011 11:19:14.537'!
test04aBetterWayOfAssertingEquality
	"Some ways of asserting equality are better than others."

	| expectedValue actualValue |
	expectedValue := xx.
	actualValue := 1 + 1.
	self assert: expectedValue equals: actualValue! !

!KoanAboutAsserts methodsFor: 'tests' stamp: 'esec 10/18/2011 11:19:14.517'!
test05fillInValues
	"Sometimes we will ask you to fill in the values."

	self assert: xx equals: 1 + 1! !

KoanCase subclass: #KoanAboutBlocks
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Koans-Abouts'!

!KoanAboutBlocks class methodsFor: 'accessing' stamp: 'pre 11/4/2011 21:40:19.672'!
priority 

	^6! !

!KoanAboutBlocks methodsFor: 'tests' stamp: 'esec 10/18/2011 11:19:15.08'!
test01whatIsABlock

	self assert: xx equals: ([ 123 ] class)   ! !

!KoanAboutBlocks methodsFor: 'tests' stamp: 'esec 11/1/2011 18:52:25.849'!
test02aBlockCanBeExecuted

	self 
		assert: xx equals: ([ 123 ] value);
		assert: xx equals: [ false and: false ] value! !

!KoanAboutBlocks methodsFor: 'tests' stamp: 'esec 11/1/2011 18:52:30.432'!
test03theLastStatementReturns

	self
		assert: xx equals: [ 123 . 456 . 789] value;
		assert: xx equals: [ 'first' . 'second'] value! !

!KoanAboutBlocks methodsFor: 'tests' stamp: 'esec 11/1/2011 18:52:33.36'!
test04blocksCanBeStored

	| storedBlock |
	
	storedBlock := [ 'result'].
	
	self assert: xx equals: storedBlock value! !

!KoanAboutBlocks methodsFor: 'tests' stamp: 'esec 11/1/2011 18:52:36.705'!
test05passParametersToBlocksButPassTheRight

	| multiply |
	
	multiply := [ :a :b | a*b ].
	
	self assert: xx equals: (multiply value: 2 value: 3).
	
	self should: [multiply value: 1] raise: xx! !

!KoanAboutBlocks methodsFor: 'tests' stamp: 'esec 11/1/2011 18:52:40.176'!
test06blocksWithTempVariables

	| processing |
	
	processing := [ :a :b |
						| tempVariable | 
						tempVariable := a + b.
						tempVariable * tempVariable ].
					
	self assert: xx equals: (processing value: 4 value: 2)! !

!KoanAboutBlocks methodsFor: 'tests' stamp: 'pre 11/5/2011 12:26:35.304'!
test07rememberTheFinalStatement

	"This is part of the buggy way of the art of SmallTalk. 
	The value of the last statement of a block is returned. Always the last!!"

	| processing |
	
	processing := [ :a :b | a. b ].
					
	self 
		assert: xx equals: (false == (processing value: true value: false));
		assert: xx equals: (true == (processing value: true value: false))! !

KoanCase subclass: #KoanAboutClasses
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Koans-Abouts'!

!KoanAboutClasses class methodsFor: 'accessing' stamp: 'pre 10/16/2011 16:13:07.54'!
priority

	^2! !

!KoanAboutClasses methodsFor: 'tests' stamp: 'esec 11/1/2011 18:52:57.585'!
test01createAnInstanceWithNew
	| anObject |
	
	anObject := Object new.
	self assert: xx equals: anObject class == Object! !

!KoanAboutClasses methodsFor: 'tests' stamp: 'pre 11/9/2011 17:33:36.139'!
test02instanceVariablesAreEncapsulated
	"First take a look at the KoanLotus class. It has two instance variables: privateInstanceVariable and publicInstanceVariable.
	Also look at the methods of the Lotus. Now what will happen down there?"

	| aLotus |
	aLotus := KoanLotus new.
	self should: [aLotus privateInstanceVariable] raise: xx
	
	"Should:Raise: executes the code in braces and looks for an exception specified after raise:"! !

!KoanAboutClasses methodsFor: 'tests' stamp: 'pre 11/5/2011 12:26:05.75'!
test03useGettersAndSetters
	| aLotus |
	
	aLotus := KoanLotus new.
	self assert: xx equals: aLotus publicInstanceVariable.
	
	aLotus publicInstanceVariable: 'anotherValue'.
	self assert: xx equals: aLotus publicInstanceVariable! !

!KoanAboutClasses methodsFor: 'tests' stamp: 'esec 11/9/2011 10:43:46.952'!
test04theTaleOfNewAndBasicNew 
	| aLotus |
	
	"The new class method calls initialize on the new instance."
	aLotus := KoanLotus new.
	self assert: xx equals: aLotus publicInstanceVariable.
	
	"basicNew doesn't call it"
	aLotus := KoanLotus basicNew.
	self assert: xx equals: aLotus publicInstanceVariable! !

!KoanAboutClasses methodsFor: 'tests' stamp: 'esec 11/1/2011 18:53:34.824'!
test05whoIAmTellsYouClass
	"Always asking yourself who you are isnt good. Use it carefully!!"

	| aLotus |
	aLotus := KoanLotus new.
	self 
		assert: xx equals: Object new class;
		assert: xx equals: aLotus class! !

!KoanAboutClasses methodsFor: 'tests' stamp: 'esec 11/1/2011 18:53:40.104'!
test06classesUnderstandCanUnderstand

	self 
		assert: xx equals: (KoanLotus canUnderstand: #publicInstanceVariable);
		assert: xx equals: (KoanLotus canUnderstand: #walk);
		assert: xx equals: (Class canUnderstand: #canUnderstand:)! !

KoanCase subclass: #KoanAboutCollectionProtocoll
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Koans-Abouts'!

!KoanAboutCollectionProtocoll class methodsFor: 'accessing' stamp: 'pre 11/4/2011 21:41:54.184'!
priority 

	^14! !

!KoanAboutCollectionProtocoll methodsFor: 'tests' stamp: 'esec 11/9/2011 10:44:05.696'!
test01includes

	| flowers |
	
	flowers := { #rose . #lily . #bindweed}.
	
	self assert: true equals: (flowers includes: xx)! !

!KoanAboutCollectionProtocoll methodsFor: 'tests' stamp: 'esec 11/9/2011 10:46:46.697'!
test02anySatisfy

	| smallNumbers |
	
	smallNumbers := { 1 . 2 . 3 . 4 . 5 . 6 }.
	
	self assert: xx equals: (smallNumbers anySatisfy: [ :aNumber | aNumber > 3] ).
	self assert: false equals: (smallNumbers anySatisfy: [ :aNumber | (aNumber raisedTo: 2) > xx ] )! !

!KoanAboutCollectionProtocoll methodsFor: 'tests' stamp: 'esec 11/9/2011 10:46:52.418'!
test03allSatisfy

	| smallNumbers |
	
	smallNumbers := { 1 . 2 . 3 . 4 . 5 . 6 }.
	
	self assert: xx equals: (smallNumbers allSatisfy: [ :aNumber | aNumber > 3] ).
	self assert: true equals: (smallNumbers allSatisfy: [ :aNumber | aNumber > xx] )! !

!KoanAboutCollectionProtocoll methodsFor: 'tests' stamp: 'esec 11/9/2011 10:50:39.736'!
test04select

	| smallNumbers |
	
	smallNumbers := { 1 . 2 . 3 . 4 . 5 . 6 }.
	
	self assert: { xx } equals: (smallNumbers select: [ :aNumber | aNumber > 3] ).
	self assert: { 2 . 4 . 6 } equals: (smallNumbers select: xx )! !

!KoanAboutCollectionProtocoll methodsFor: 'tests' stamp: 'esec 11/9/2011 10:45:45.352'!
test05reject

	| smallNumbers |
	
	smallNumbers := { 1 . 2 . 3 . 4 . 5 . 6 }.
	
	"You have previously learned about the power of select. Now what might be its counterpart?"
	
	self assert: { 1 . 2 . 3 } equals: (smallNumbers xx: [ :aNumber | aNumber > 3] )! !

!KoanAboutCollectionProtocoll methodsFor: 'tests' stamp: 'esec 11/9/2011 10:51:38.273'!
test06mathStuff
	"Collections have some convenience functions for mathematical operations."

	| smallNumbers |
	
	smallNumbers := { 2 . 3 }.
	
	self assert: xx equals: (smallNumbers sum ).
	self assert: xx equals: (smallNumbers max ).
	self assert: xx equals: (smallNumbers range ).
	self assert: xx equals: (smallNumbers squared )! !

!KoanAboutCollectionProtocoll methodsFor: 'tests' stamp: 'esec 11/9/2011 10:52:35.465'!
test07detect

	| smallNumbers |
	
	smallNumbers := { 1 . 2 . 3 . 4  }.
	
	self assert: xx equals: (smallNumbers detect: [ :a | a > 2 ] ).
	self assert: 1 equals: (smallNumbers detect: xx )! !

!KoanAboutCollectionProtocoll methodsFor: 'tests' stamp: 'esec 11/9/2011 10:53:03.375'!
test08detectIfNone

	| smallNumbers |
	
	smallNumbers := { 1 . 2 . 3 . 4  }.
	
	self assert: xx equals: (smallNumbers detect: [ :aNumber | aNumber < 0 ] ifNone: [ 10 ] ).
	self assert: { 22 . 31 } equals: (smallNumbers detect: xx ifNone: xx )! !

!KoanAboutCollectionProtocoll methodsFor: 'tests' stamp: 'pre 11/7/2011 18:46:54.559'!
test09collect

	| smallNumbers |
	
	smallNumbers := { 1 . 2 . 3 . 4  }.
	
	self assert: { xx } equals: (smallNumbers collect: [ :aNumber | aNumber + 10 ] ).
	self assert: { false . false . true . true } equals: (smallNumbers collect: xx )! !

!KoanAboutCollectionProtocoll methodsFor: 'tests' stamp: 'esec 11/9/2011 11:01:51.648'!
test10inject

	| words |
	
	words := { 'Some' . 'single' . 'words' }.
	
	self assert: xx equals:
		(words inject: '' into: [ :totalString :value | totalString , value ]).
	
	self assert: 'TheseSomesinglewords' equals:
		(words inject: xx into: [ :totalString :value | totalString , value ]).
	
	self assert: ' Some single words' equals: (words inject: xx into: xx)! !

!KoanAboutCollectionProtocoll methodsFor: 'tests' stamp: 'pre 11/1/2011 19:07:10.584'!
test11sizeAndCount

	| words |
	
	words := { 'Some' . 'single' . 'words' }.
	
	self assert: xx equals: (words size).
	self assert: xx equals: (words count: [ :aWord | aWord size = 4]).
	self assert: 2 equals: (words count: [ :aWord | xx])   ! !

!KoanAboutCollectionProtocoll methodsFor: 'tests' stamp: 'esec 11/9/2011 10:45:58.394'!
test12do
	"The generic path of iterations for collections is the do method. 
	You can replace all other methods by a do construct. 
	But you should really only do this if you can't achieve your goal with other collection methods."

	| words completeLength |
	
	completeLength := 0.
	
	words := { 'How' . 'dare' . 'you' }.
	(words do: [ :aWord | 
				completeLength := completeLength + aWord size]).
	
	self assert: xx equals: completeLength! !

!KoanAboutCollectionProtocoll methodsFor: 'tests' stamp: 'esec 11/9/2011 11:03:53.449'!
test13specialIterators
	"Some collections have special iterators in their art of iteration."
	
	self assert: xx equals: (Dictionary canUnderstand: #keysAndValuesDo:).
	self assert: xx equals: (Dictionary canUnderstand: #associationsDo:).
	self assert: xx equals: (String canUnderstand: #wordsDo:).
	self assert: xx equals: (Matrix canUnderstand: #indicesCollect:)! !

KoanCase subclass: #KoanAboutCollections
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Koans-Abouts'!

!KoanAboutCollections class methodsFor: 'accessing' stamp: 'pre 11/4/2011 21:41:44.378'!
priority 

	^12! !

!KoanAboutCollections methodsFor: 'tests' stamp: 'esec 11/8/2011 09:57:56.694'!
test01collectionsCanComeInDifferentFlavours
	
	self assert: xx equals: (Collection new) isCollection.   
	self assert: xx equals: (OrderedCollection new) isCollection.
	self assert: xx equals: (Set new) isCollection.    
	self assert: xx equals: (Array new) isCollection.  
	self assert: xx equals: (String new) isCollection.  
	self assert: xx equals: (Dictionary new) isCollection.  
	"...but whait a minute..."
	self assert: xx equals: (Symbol new) isCollection! !

!KoanAboutCollections methodsFor: 'tests' stamp: 'esec 11/9/2011 10:43:18.729'!
test02collectionsStartAtFirst

	| aCollection |
	
	aCollection := { 2 . 3 . 4 . 5}.
	self assert: xx equals: aCollection first.
	self assert: aCollection first equals: (aCollection at: xx)! !

!KoanAboutCollections methodsFor: 'tests' stamp: 'esec 11/9/2011 10:43:15.12'!
test03arraysAreImmutable
	| array |
	
	array := Array new.
	
	self should: [array add: #someElement] raise: xx! !

!KoanAboutCollections methodsFor: 'tests' stamp: 'esec 11/9/2011 10:43:08.745'!
test04orderedCollection
	| collection |
	
	collection := {'I' . 'am' . 'a' . 'ordered' . 'collection!!'} asOrderedCollection.
	
	 self assert: {'ordered' . 'collection!!' . 'am' . 'a' . 'I'} asOrderedCollection 
		  			= (collection sorted: xx)! !

!KoanAboutCollections methodsFor: 'tests' stamp: 'esec 11/9/2011 10:43:04.489'!
test05set
	| set |
	
	set := {'I' . 'am' . 'a' . 'great' . 'set!!'} asSet.
	
	self assert: (set add: 'a') equals: xx.
	self assert: (set add: 'some') equals: xx.
	self assert: set equals: xx! !

!KoanAboutCollections methodsFor: 'tests' stamp: 'esec 11/9/2011 10:43:01.913'!
test06setsBiggerBrotherTheBag
	| bag |
	
	bag := {'I' . 'am' . 'a' . 'great' . 'bag!!'} asBag.
	
	self assert: (bag add: 'a') equals: xx.
	self assert: (bag add: 'some') equals: xx.
	self assert: bag equals: xx! !

!KoanAboutCollections methodsFor: 'tests' stamp: 'pre 11/7/2011 19:32:52.393'!
test07dictionary

	| dict |
	
	dict := Dictionary new
						at: #key put: 'aValue' ;
						at: #anotherKey put: 'aSecondValue';
						yourself.
						
	self assert: (dict at: xx)equals: 'aSecondValue'.
	self assert: xx equals: (dict associationAt: #key) class! !

!KoanAboutCollections methodsFor: 'tests' stamp: 'esec 11/9/2011 10:42:55.728'!
test08identityDictionaryIsRigorous

	| identityDict |
	
	identityDict := IdentityDictionary new
						at: 'key' put: 'aValue' ;
						yourself.
						
	self assert: (identityDict at: xx) equals: 'aValue'.
	identityDict at: (String newFrom: 'key') put: 'thirdValue'.
	self assert: (identityDict keys) equals: xx

	"What is the difference to the less rigorous brother dictionary?"
	"It's the comparison of keys. IdentityDictionary uses ==!!"! !

!KoanAboutCollections methodsFor: 'tests' stamp: 'esec 11/9/2011 10:45:23.313'!
test09sortedCollection

	| numbers sortNumbers |
	
	numbers := { 5 . 3 . 2 }.
	self assert: xx equals: (numbers asSortedCollection asArray).
	
	sortNumbers := { 6 . 7 . 3 . 2} asSortedCollection.
	self assert: ((sortNumbers sort: xx) asArray) equals: { 7 . 6 . 3 . 2}.
	self assert: (sortNumbers add: 5; asArray) equals: xx! !

KoanCase subclass: #KoanAboutControlStatements
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Koans-Abouts'!

!KoanAboutControlStatements class methodsFor: 'accessing' stamp: 'pre 11/4/2011 21:40:59.02'!
priority 

	^7! !

!KoanAboutControlStatements methodsFor: 'tests' stamp: 'pre 11/7/2011 18:52:25.038'!
test01statementsAreMethodsOfBooleanClass
	"Even statements are implemented as methods.
	Always remember: everything is a message send!!"

	| expected |
	expected := xx.
	self assert: expected equals: (Boolean canUnderstand: #or:).
	self assert: expected equals: (Boolean canUnderstand: #and:).
	self assert: expected equals: (Boolean canUnderstand: #ifTrue:).
	self assert: expected equals: (Boolean canUnderstand: #ifFalse:).
	self assert: expected equals: (Boolean canUnderstand: #ifNil:).
	self assert: expected equals: (Boolean canUnderstand: #ifNotNil:)! !

!KoanAboutControlStatements methodsFor: 'tests' stamp: 'pre 11/5/2011 12:28:26.536'!
test02statementsTakeBlocks
	"all statements take blocks as arguments.
	the blocks will only be evaluated when necessary."
	
	|a b expectedNumber |
	a := 1. b := 2.
	true or: [a := b. true].
	expectedNumber := xx.
	self assert: expectedNumber equals: a.
	
	a := 1. b := 2.
	false or: [a := b. true].
	expectedNumber := xx.
	self assert: expectedNumber equals: a! !

!KoanAboutControlStatements methodsFor: 'tests' stamp: 'esec 11/1/2011 18:51:50.289'!
test03conditionalExecution
	| a b |
	a := 1.
	b := 2.
	
	false
		ifTrue: [ a := 3 ]
		ifFalse: [ b := 3 ].
	
	self assert: xx equals: a.
	self assert: xx equals: b! !

!KoanAboutControlStatements methodsFor: 'tests' stamp: 'esec 11/1/2011 18:51:53.36'!
test04conditionalExecutionWithExpressions
	| a b |
	
	a := 1. b := 2.
	(true and: [xx]) ifTrue: [a := b].
	self assert: b equals: a! !

!KoanAboutControlStatements methodsFor: 'tests' stamp: 'esec 11/1/2011 18:51:56.056'!
test05statementsInAssignments
	| a b |
	
	a := true and: false.
	self assert: xx equals: a.
	
	b := a ifTrue: [1] ifFalse: [2].
	self assert: xx equals: b! !

!KoanAboutControlStatements methodsFor: 'tests' stamp: 'esec 11/1/2011 18:51:58.889'!
test06implication
	| a |
	
	self assert: xx equals: true ==> [false].
	self assert: xx equals: false ==> [false].
	
	a := 1.
	true ==> [a := 2].
	self assert: xx equals: a.
	
	a := 1.
	false ==> [a := 2].
	self assert: xx equals: a! !

!KoanAboutControlStatements methodsFor: 'tests' stamp: 'esec 11/1/2011 18:52:01.498'!
test07nil
	| b |
	
	nil ifNil: [b := 1] ifNotNil: [b := 2].
	self assert: xx equals: b.
	
	5 ifNil: [b := 1] ifNotNil: [b := 2].
	self assert: xx equals: b! !

!KoanAboutControlStatements methodsFor: 'tests' stamp: 'esec 11/1/2011 18:16:27.889'!
test08loopsOperateOnBlocks
	self assert: xx equals: (Boolean canUnderstand: #whileTrue:).
	
	self assert: xx equals: (BlockClosure canUnderstand: #whileTrue:).
	self assert: xx equals: (BlockClosure canUnderstand: #whileFalse:).
	self assert: xx equals: (BlockClosure canUnderstand: #whileNil:)! !

!KoanAboutControlStatements methodsFor: 'tests' stamp: 'esec 11/1/2011 18:52:06.602'!
test09loopExecution
	|a|
	
	a := 2.
	[a < 10] whileTrue: [a := a*a].

	self assert: xx equals: a! !

KoanCase subclass: #KoanAboutDiceProject
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Koans-Abouts'!

!KoanAboutDiceProject class methodsFor: 'accessing' stamp: 'esec 11/9/2011 11:16:56.711'!
priority

	^30! !

!KoanAboutDiceProject methodsFor: 'tests' stamp: 'esec 11/9/2011 11:20:53.561'!
test01AboutDiceProject
	| dice |
	
	dice := KoanCrystalDice new.
	self assert: (dice respondsTo: #roll:).	! !

!KoanAboutDiceProject methodsFor: 'tests' stamp: 'esec 11/9/2011 11:35:32.169'!
test02rollingTheDiceReturnsASetOfIntegersInsideTheRange
	| dice |
	
	dice := KoanCrystalDice newWithRange: 1 to: 16.

	dice roll:5.
	self assert: (dice values isKindOf: Array) description: 'should be an array'.  	
	self assert: 5 equals: (dice values size).
	dice values do: [ :value |
		self assert: ((value >= 1) and: value <= 16) description: 'value must be between 1 and 16!!']	! !

!KoanAboutDiceProject methodsFor: 'tests' stamp: 'esec 11/9/2011 11:34:43.28'!
test03diceValuesDoNotChangeUnlessExplicitlyRolled
	| dice firstTime secondTime |
	
	dice := KoanCrystalDice newWithRange: 1 to: 6.

	dice roll:5.
	firstTime := dice values.
	secondTime := dice values.
	self assert: firstTime equals: secondTime.! !

!KoanAboutDiceProject methodsFor: 'tests' stamp: 'pre 11/10/2011 13:54:01.07'!
test04diceValuesShouldChangeBetweenRolls
	| dice firstTime secondTime |
	
	dice := KoanCrystalDice newWithRange: 1 to: 6.

	dice roll:5.
	firstTime := dice values.
	dice roll:5.
	secondTime := dice values.
	"Two rolls should not be equal"
	self assert: (firstTime = secondTime) not! !

!KoanAboutDiceProject methodsFor: 'tests' stamp: 'esec 11/9/2011 11:35:20.848'!
test05youCanRollDifferentNumbersOfDice
	| dice |
	
	dice := KoanCrystalDice newWithRange: 1 to: 6.

	dice roll:3.
	self assert: 3 equals: dice values size.   
	dice roll:1.
	self assert: 1 equals: dice values size.! !

KoanCase subclass: #KoanAboutInheritance
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Koans-Abouts'!

!KoanAboutInheritance class methodsFor: 'accessing' stamp: 'pre 11/4/2011 21:38:52.894'!
priority 

		^3! !

!KoanAboutInheritance methodsFor: 'tests' stamp: 'esec 11/1/2011 18:53:49.153'!
test01inheritanceVariableInheritanceExists

	"Take a look at the KoanBonsai classes: KoanBonsai, KoanMapleBonsai, KoanAiderBonsai. 
	Take a special look at their instance variables."
	
	| aMapleBonsai |
	
	aMapleBonsai := KoanMapleBonsai new.
	aMapleBonsai height: 10.
	
	self assert: xx equals: aMapleBonsai height! !

!KoanAboutInheritance methodsFor: 'tests' stamp: 'esec 11/1/2011 18:53:52.415'!
test02methodInheritanceAndOverwrittingExist

	| aBonsai aMapleBonsai anAiderBonsai |
	
	aBonsai := KoanBonsai new.
	anAiderBonsai := KoanAiderBonsai new.
	aMapleBonsai := KoanMapleBonsai new.
	
	self
		assert: xx equals: aBonsai color;
		assert: xx equals: anAiderBonsai color;
		assert: xx equals: aMapleBonsai color! !

!KoanAboutInheritance methodsFor: 'tests' stamp: 'esec 11/1/2011 18:53:55.521'!
test03abstractMethodsAreSubclassResponsibility

	| aBonsai anAiderBonsai |
	
	aBonsai := KoanBonsai new.
	anAiderBonsai := KoanAiderBonsai new.
	
	self should: [aBonsai fruits] raise: xx.  
	
	self assert: xx equals: anAiderBonsai fruits! !

!KoanAboutInheritance methodsFor: 'tests' stamp: 'esec 11/1/2011 18:53:58.552'!
test04askSuperWithSuper

	| aMapleBonsai |
	
	aMapleBonsai := KoanMapleBonsai new.
	
	self assert: xx equals: aMapleBonsai width! !

KoanCase subclass: #KoanAboutMeta
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Koans-Abouts'!

!KoanAboutMeta class methodsFor: 'as yet unclassified' stamp: 'pre 12/9/2011 14:49:59.856'!
priority

	^25! !

!KoanAboutMeta methodsFor: 'as yet unclassified' stamp: 'pre 12/9/2011 15:14:27.194'!
test01callAMethodOrLeaveAMessage

	| aBonsai |
	
	aBonsai := KoanAiderBonsai new.
	
	self assert: (aBonsai width) equals: (aBonsai perform: xx)! !

!KoanAboutMeta methodsFor: 'as yet unclassified' stamp: 'pre 12/9/2011 15:14:35.418'!
test02sendAMessageWithAttachedArguments

	| aBonsai |
	
	aBonsai := KoanAiderBonsai new.
	
	aBonsai perform: xx with: 10.
	self assert: 10 equals: aBonsai height! !

!KoanAboutMeta methodsFor: 'as yet unclassified' stamp: 'pre 12/9/2011 15:14:44.011'!
test03casesByMessageNames
	"You know how this works. But use it wisely. This can lead you to the
	dark side of programming where debugging is merely a hunt for
	ghosts in a bamboo garden."


	| aBonsai |
	
	aBonsai := KoanMetaBonsai new.
	
	self assert: ('fruit 2') equals: (aBonsai perform: (('fruit', (xx asString)) xx ) )  
! !

!KoanAboutMeta methodsFor: 'as yet unclassified' stamp: 'pre 12/9/2011 15:14:59.42'!
test04classesAreObjectsAndHaveClassesHaveClasses

	| anObject |
	
	anObject := Object new.
	
	self assert: xx equals: anObject class.
	self assert: xx equals: anObject class class.
	self assert: xx equals: anObject class class class.
	self assert: xx equals: anObject class class class class! !

!KoanAboutMeta methodsFor: 'as yet unclassified' stamp: 'pre 12/9/2011 15:15:04.893'!
test05classesHaveAcessToInstances
	"This is another powerful technique but you have to be careful using it!!"

	| bonsaiOne bonsaiTwo |
	
	bonsaiOne := KoanBambooBonsai new.
	bonsaiTwo := KoanBambooBonsai new.
	
	self assert: 2 equals: (KoanBambooBonsai xx size)! !

!KoanAboutMeta methodsFor: 'as yet unclassified' stamp: 'pre 12/9/2011 15:15:15.515'!
test06classesHaveAcessToHierachy
	
	| aBonsai |
	
	aBonsai := KoanAiderBonsai new.
	
	self assert: xx equals: (aBonsai class superclass).
	self assert: xx equals: (KoanBonsai subclasses)! !

KoanCase subclass: #KoanAboutNil
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Koans-Abouts'!

!KoanAboutNil class methodsFor: 'accessing' stamp: 'esec 11/9/2011 10:51:21.456'!
numberOfAllInstancesOfNil
	^ (UndefinedObject allInstances size)! !

!KoanAboutNil class methodsFor: 'accessing' stamp: 'pre 11/4/2011 21:39:31.038'!
priority

	^5! !

!KoanAboutNil methodsFor: 'tests' stamp: 'esec 11/9/2011 10:51:05.352'!
test01thereIsOnlyOneNil

	self assert: xx equals: self class numberOfAllInstancesOfNil! !

!KoanAboutNil methodsFor: 'tests' stamp: 'pre 11/9/2011 17:23:00.842'!
test02variablesAreInitializedToNil

	| aVariable |
	
	self assert: xx equals: aVariable.! !

!KoanAboutNil methodsFor: 'tests' stamp: 'pre 11/7/2011 19:04:20.499'!
test03nilIsJustAnotherObject

	self assert: xx equals: (nil class)
	
	"But inspect it and you will find nothing. Because nil has no meaning."
	"Nil is nil."! !

KoanCase subclass: #KoanAboutObjects
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Koans-Abouts'!

!KoanAboutObjects class methodsFor: 'accessing' stamp: 'pre 10/16/2011 16:12:57.726'!
priority

	^1! !

!KoanAboutObjects methodsFor: 'tests' stamp: 'esec 11/1/2011 18:48:35.833'!
test01everythingIsAnObject

	self 
		assert: xx equals: (21 isKindOf: Object);
		assert: xx equals: (1.321 isKindOf: Object);
		assert: xx equals: ('string' isKindOf: Object);
		assert: xx equals: ((Object new) isKindOf: Object);
		assert: xx equals: (Smalltalk isKindOf: Object)! !

!KoanAboutObjects methodsFor: 'tests' stamp: 'pre 11/9/2011 17:35:03.227'!
test02everyObjectHasAnId

	| anObject |
	
	anObject := Object new.

	self assert: xx equals: (anObject hash class)
	
	"Remember: Everything is an Object, even classes."
	"The ancient button of implementors might help to find the true nature of hash."! !

!KoanAboutObjects methodsFor: 'tests' stamp: 'pre 11/9/2011 14:11:34.814'!
test03everyObjectHasADifferentId

	| anObject anotherObject |
	
	anObject := Object new.
	anotherObject := Object new.

	self assert: xx equals: (anObject ~~ anotherObject)! !

!KoanAboutObjects methodsFor: 'tests' stamp: 'pre 11/9/2011 14:11:40.442'!
test04butNotSmallIntegers

	| aNumber anotherNumber |
	
	aNumber := 1.
	anotherNumber := 1.

	self assert: xx equals: (aNumber ~~ anotherNumber)
	
	"Now think about this: What is the implication for the identity check on small integers?"! !

!KoanAboutObjects methodsFor: 'tests' stamp: 'pre 11/9/2011 14:11:47.401'!
test05copyObjectsWithNewFrom

	| anyObject aNewObject |
	
	anyObject := Object new.
	aNewObject  := Object newFrom: anyObject.

	self assert: xx equals: (anyObject ~~ aNewObject)! !

!KoanAboutObjects methodsFor: 'tests' stamp: 'pre 10/3/2016 12:51'!
test06useCascadesToNotRepeatButBeCareful

	| result |
	
	result := 'abc'
				reversed;
				asUppercase.

	self assert: xx equals: result.
	
	result := Set new
				add: 1;
				add: 2.
				
	self assert: xx equals: result isCollection.! !

!KoanAboutObjects methodsFor: 'tests' stamp: 'pre 10/3/2016 12:51'!
test07yourselfIsTheObjectItself

	| result |
	
	result := 'abc'
				reversed;
				asUppercase;
				yourself.

	self assert: xx equals: result.
	
	result := Set new
				add: 1;
				add: 2;
				yourself.
				
	self assert: xx equals: result isCollection.! !

KoanCase subclass: #KoanAboutStrings
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Koans-Abouts'!

!KoanAboutStrings class methodsFor: 'accessing' stamp: 'pre 11/4/2011 21:41:14.162'!
priority 

	^8! !

!KoanAboutStrings methodsFor: 'tests' stamp: 'esec 11/1/2011 18:51:25.642'!
test01stringsAreCollections
	self assert: xx equals: ('Hello World' isKindOf: Collection).
	
	self assert: xx equals: ('Hello World' first).
	self assert: xx equals: ('Hello World' at: 6).
	
	self assert: xx equals: ('Hello World' copyFrom: 5 to: 7).
	self assert: xx equals: ('Hello World' last: 5)! !

!KoanAboutStrings methodsFor: 'tests' stamp: 'esec 11/1/2011 18:51:22.929'!
test02escaping
	self assert: xx equals: 'I''m here'! !

!KoanAboutStrings methodsFor: 'tests' stamp: 'esec 11/1/2011 18:45:42.305'!
test03concatenation
	| a b |
	a := 'Hello World'.
	
	self assert: xx equals: 'Hello' , ' ' , 'World'.
	
	b := String
		streamContents: [ :stream | 
			stream
				nextPutAll: 'Hello';
				nextPutAll: ' ';
				nextPutAll: 'World' ].
	self assert: xx equals: b! !

!KoanAboutStrings methodsFor: 'tests' stamp: 'esec 11/1/2011 18:51:16.56'!
test04newLine
	| a |
	a := 'Hello
World'.

	self assert: xx equals: 'Hello' , Character cr asString , 'World'! !

!KoanAboutStrings methodsFor: 'tests' stamp: 'esec 11/1/2011 18:45:56.474'!
test05formatting
	| a b c |
	a := 'Hello World'.
	b := '{ } \ foo 12 bar string'.
	c := '{ } \\ foo 12 bar string'.
	
	self assert: xx equals: ('Hello {1}' format: {'World'}).
	self assert: xx equals:
		('\{ \} \\ foo {1} bar {2}' format: {12. 'string'})! !

!KoanAboutStrings methodsFor: 'tests' stamp: 'esec 11/1/2011 18:50:10.609'!
test06stringsAreNotUnique
	| a b |
	a := 'Hello World'.
	b := 'Hello', ' ', 'World'.
	
	self assert: xx equals: a == b.
	self assert: xx equals: a = b! !

KoanCase subclass: #KoanAboutSymbols
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Koans-Abouts'!

!KoanAboutSymbols class methodsFor: 'accessing' stamp: 'pre 11/4/2011 21:41:27.638'!
priority 

	^10! !

!KoanAboutSymbols methodsFor: 'tests' stamp: 'rms 11/1/2011 17:41'!
test01symbolsAreSymbols
	| symbol |
	
	symbol := #Smalltalk.
	self assert: xx equals: symbol isSymbol.
	! !

!KoanAboutSymbols methodsFor: 'tests' stamp: 'rms 11/1/2011 17:44'!
test02symbolsCanBeCompared
	| symbol1 symbol2 symbol3 |
	
	symbol1 := #aSymbol.
	symbol2 := #aSymbol.
	symbol3 := #somethingElse.
	
	self assert: xx equals: symbol1 == symbol2.
	self assert: xx equals: symbol1 == symbol3.     ! !

!KoanAboutSymbols methodsFor: 'tests' stamp: 'pre 11/9/2011 14:12:23.785'!
test03identicalSymbolsAreASingleIdenticalObject
	| symbol1 symbol2 |
	
	symbol1 := #aSymbol.
	symbol2 := #aSymbol.
	
	self assert: xx equals: symbol1 == symbol2. ! !

!KoanAboutSymbols methodsFor: 'tests' stamp: 'pre 11/8/2016 19:00'!
test04methodNamesBecomeSymbols
	| symbolsAsStrings |
	
	symbolsAsStrings := Symbol allSymbols do: [:x | x asString. ].
	
	self assert: xx equals: (symbolsAsStrings includes: 'test04methodNamesBecomeSymbols').
	
	" If you want to crack a hard nut think about this:
         Why do we convert the list of symbols to strings and then compare
         against the string value rather than against symbols?
         Hint: How is the set of all symbols affected when you change the 
         source code to use symbols?"! !

!KoanAboutSymbols methodsFor: 'tests' stamp: 'rms 11/1/2011 17:56'!
test05symbolsCanBeMadeFromStrings
	| string |
	
	string := 'Cats and dogs'.
	
	self assert: xx equals: string asSymbol.   ! !

!KoanAboutSymbols methodsFor: 'tests' stamp: 'rms 11/1/2011 17:58'!
test06symbolsWithSpacesCanBeMade
	| symbol |
	
	symbol := #'Cats and dogs'.
	
	self assert: symbol equals: xx asSymbol.   ! !

!KoanAboutSymbols methodsFor: 'tests' stamp: 'pre 11/9/2011 17:25:12.986'!
test07symbolsAreSpecialStrings
	| symbol |

	symbol := #Smalltalk.
	
	self assert: xx equals: symbol isString.
	self assert: xx equals: (symbol = 'Smalltalk')! !

!KoanAboutSymbols methodsFor: 'tests' stamp: 'pre 11/9/2011 19:49:21.606'!
test08symbolsAreImmutable
	| symbol |

	symbol := #notAString.
	
	self should: [symbol at: 1 put: 'a' ] raise: xx! !

!KoanAboutSymbols methodsFor: 'tests' stamp: 'rms 11/1/2011 18:11'!
test09symbolsCanBeDynamicallyCreated

	self assert: xx equals: 'cats' , 'dogs' asSymbol .  ! !

KoanCase subclass: #KoanAboutTrueAndFalse
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Koans-Abouts'!

!KoanAboutTrueAndFalse class methodsFor: 'accessing' stamp: 'pre 11/4/2011 21:39:14.12'!
priority 

	^4! !

!KoanAboutTrueAndFalse methodsFor: 'tests' stamp: 'esec 11/1/2011 18:54:41.177'!
test01trueAndFalseAreObjects

	self
		assert: xx equals: true class;
		assert: xx equals: (true class allSuperclasses includes: Object);
		assert: xx equals: false class;
		assert: xx equals: (false class allSuperclasses includes: Object)! !

!KoanAboutTrueAndFalse methodsFor: 'tests' stamp: 'esec 11/1/2011 18:54:45.593'!
test02andIsAMessageOfBoolean

	self
		assert: xx equals: (Boolean canUnderstand: #and:);
		assert: xx equals: (true and: false)! !

!KoanAboutTrueAndFalse methodsFor: 'tests' stamp: 'esec 11/1/2011 18:54:51.296'!
test03orIsAMessageOfBoolean

	self
		assert: xx equals: (Boolean canUnderstand: #or:);
		assert: xx equals: (true or: false)! !

!KoanAboutTrueAndFalse methodsFor: 'tests' stamp: 'esec 11/1/2011 18:55:06.048'!
test04alsoNotAndImplies

	self
		assert: xx equals: (false not);
		assert: xx equals: (false ==> true)! !

!KoanCase class methodsFor: 'accessing' stamp: 'esec 10/10/2011 16:40'!
priority
	^ 0! !

!KoanCase methodsFor: 'initialize-release' stamp: 'esec 11/9/2011 10:50:57.297'!
initialize
	super initialize.
	xx := 'FILL ME IN'! !

Object subclass: #KoanBambooBonsai
	instanceVariableNames: 'height'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Koans-Bonsai'!

Object subclass: #KoanBonsai
	instanceVariableNames: 'height'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Koans-Bonsai'!

KoanBonsai subclass: #KoanAiderBonsai
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Koans-Bonsai'!

!KoanAiderBonsai methodsFor: 'accessing' stamp: 'pre 10/16/2011 16:51:18.832'!
fruits

	^ 'cones'! !

!KoanBonsai methodsFor: 'accessing' stamp: 'pre 10/16/2011 16:40:15.026'!
color

	^ 'green'! !

!KoanBonsai methodsFor: 'accessing' stamp: 'pre 10/16/2011 16:49:09.832'!
fruits

	self subclassResponsibility ! !

!KoanBonsai methodsFor: 'accessing' stamp: 'pre 10/16/2011 16:39:52.5'!
height
	"Answer the value of height"

	^ height! !

!KoanBonsai methodsFor: 'accessing' stamp: 'pre 10/16/2011 16:39:52.508'!
height: anObject
	"Set the value of height"

	height := anObject! !

!KoanBonsai methodsFor: 'accessing' stamp: 'pre 10/16/2011 16:40:51.014'!
initialize

	self height: 0! !

!KoanBonsai methodsFor: 'accessing' stamp: 'pre 10/16/2011 16:55:14.152'!
width

	^ 4! !

KoanBonsai subclass: #KoanMapleBonsai
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Koans-Bonsai'!

!KoanMapleBonsai methodsFor: 'accessing' stamp: 'pre 10/16/2011 16:46:35.85'!
color

	^ 'red'! !

!KoanMapleBonsai methodsFor: 'accessing' stamp: 'pre 10/16/2011 16:51:43.142'!
fruits

	^ 'maple syrup'! !

!KoanMapleBonsai methodsFor: 'accessing' stamp: 'pre 10/16/2011 16:55:32.388'!
width

	^ super width + 5! !

Object subclass: #KoanCrystalDice
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Koans-Abouts'!

Object subclass: #KoanInterface
	instanceVariableNames: 'shoutboxContent result progress skippedKoans'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Koans-Core'!

!KoanInterface methodsFor: 'actions' stamp: 'rms 11/7/2011 22:00'!
allSkipped

	^(self skippedKoans size = KoanCase allSubclasses size)! !

!KoanInterface methodsFor: 'actions' stamp: 'esec 11/1/2011 14:38:41.033'!
browse
	(self result notNil and: [ self result failedMethod notNil ])
		ifTrue: [ StandardToolSet browse: self result failedMethod actualClass selector: self result failedMethod methodSymbol ]! !

!KoanInterface methodsFor: 'building' stamp: 'esec 11/1/2011 14:15:21.415'!
browseButtonFrame
	^LayoutFrame new
		leftFraction: 1 offset: (self buttonWidth * 2) negated;
		topFraction: 1 offset: self progressHeight negated;
		rightFraction: 1 offset: self buttonWidth negated;
		bottomFraction: 1 offset: 0! !

!KoanInterface methodsFor: 'building' stamp: 'esec 11/1/2011 14:16:00.336'!
buildBrowseButtonWith: aBuilder
	^ (aBuilder pluggableButtonSpec new)
		model: self;
		label: ' Browse ';
		action: #browse! !

!KoanInterface methodsFor: 'building' stamp: 'esec 10/10/2011 15:27'!
buildProgressWith: aBuilder
	^ (KoanProgressSpec new)
		model: self;
		progressAccessor: #progress! !

!KoanInterface methodsFor: 'building' stamp: 'esec 11/1/2011 14:13:53.008'!
buildRunButtonWith: aBuilder
	^ (aBuilder pluggableButtonSpec new)
		model: self;
		label: ' Run ';
		action: #run! !

!KoanInterface methodsFor: 'building' stamp: 'rms 10/26/2011 17:11'!
buildShoutboxWith: aBuilder
	^ aBuilder pluggableTextSpec new 
		model: self;
		getText: #shoutboxContent.! !

!KoanInterface methodsFor: 'building' stamp: 'rms 11/7/2011 18:14'!
buildSkipButtonWith: aBuilder
	^ (aBuilder pluggableButtonSpec new)
		model: self;
		label: ' Skip!! ';
		action: #skip! !

!KoanInterface methodsFor: 'building' stamp: 'rms 11/7/2011 18:15'!
buildWith: aBuilder
	| window |
	window := aBuilder pluggableWindowSpec new
		model: self; 
		label: self label;
		extent: self extent;
		children: (OrderedCollection new 
			add: ((self buildShoutboxWith: aBuilder)
				frame: self shoutboxFrame;
				yourself);
			add: ((self buildProgressWith: aBuilder)
				frame: self progressFrame;
				yourself);
			add: ((self buildSkipButtonWith: aBuilder)
				frame: self skipButtonFrame;
				yourself);
			add: ((self buildBrowseButtonWith: aBuilder)
				frame: self browseButtonFrame;
				yourself);
			add: ((self buildRunButtonWith: aBuilder)
				frame: self runButtonFrame;
				yourself);
			yourself);
		yourself.
	^ aBuilder build: window.! !

!KoanInterface methodsFor: 'accessing' stamp: 'esec 10/10/2011 15:56'!
buttonWidth
	^ 85! !

!KoanInterface methodsFor: 'accessing' stamp: 'esec 10/10/2011 14:46'!
extent
	^ 640 @ 480! !

!KoanInterface methodsFor: 'initialize-release' stamp: 'wm 10/30/2013 11:32'!
initialize
	super initialize.
	self progress: 0;
		shoutboxContent: self welcomeMessage;
		skippedKoans: OrderedCollection new.! !

!KoanInterface methodsFor: 'accessing' stamp: 'esec 10/10/2011 14:46'!
label
	^ 'Koans'! !

!KoanInterface methodsFor: 'accessing' stamp: 'esec 11/1/2011 12:08:44.264'!
progress
	^ progress! !

!KoanInterface methodsFor: 'accessing' stamp: 'esec 11/1/2011 12:14:31.021'!
progress: anObject
	progress := anObject.
	self changed: #progress! !

!KoanInterface methodsFor: 'building' stamp: 'rms 11/7/2011 18:19'!
progressFrame
	^LayoutFrame new
		leftFraction: 0 offset: 0;
		topFraction: 1 offset: self progressHeight negated;
		rightFraction: 1 offset: (self buttonWidth * 3) negated;
		bottomFraction: 1 offset: 0! !

!KoanInterface methodsFor: 'accessing' stamp: 'esec 10/10/2011 14:23'!
progressHeight
	^Preferences standardButtonFont height + 25! !

!KoanInterface methodsFor: 'accessing' stamp: 'esec 10/21/2011 18:01:21.053'!
result
	^ result! !

!KoanInterface methodsFor: 'accessing' stamp: 'esec 11/1/2011 12:14:21.692'!
result: anObject
	result := anObject! !

!KoanInterface methodsFor: 'actions' stamp: 'rms 12/9/2011 14:55'!
run

	self allSkipped ifFalse: [self shoutboxContent:
			(Text streamContents: [ :stream | 
				| path |
				path := KoanPath on: stream.
				path previousResult: self result.
				self
					result: (path walkWhileIgnoring: self skippedKoans);
					updateProgress ])].! !

!KoanInterface methodsFor: 'building' stamp: 'esec 11/1/2011 14:14:35.16'!
runButtonFrame
	^LayoutFrame new
		leftFraction: 1 offset: self buttonWidth negated;
		topFraction: 1 offset: self progressHeight negated;
		rightFraction: 1 offset: 0;
		bottomFraction: 1 offset: 0! !

!KoanInterface methodsFor: 'accessing' stamp: 'esec 10/12/2011 14:07:57.581'!
shoutboxContent
	^ shoutboxContent! !

!KoanInterface methodsFor: 'accessing' stamp: 'esec 10/12/2011 14:13:44.406'!
shoutboxContent: anObject
	shoutboxContent := anObject.
	self changed: #shoutboxContent! !

!KoanInterface methodsFor: 'building' stamp: 'esec 10/10/2011 14:47'!
shoutboxFrame
	^LayoutFrame new
		leftFraction: 0 offset: 0;
		topFraction: 0 offset: 0;
		rightFraction: 1 offset: 0;
		bottomFraction: 1 offset: self progressHeight negated + 4! !

!KoanInterface methodsFor: 'actions' stamp: 'rms 11/7/2011 19:28'!
skip

	self result ifNotNil: [
		self skippedKoans addIfNotPresent: self result currentCase priority. 
		self run].! !

!KoanInterface methodsFor: 'building' stamp: 'rms 11/7/2011 18:18'!
skipButtonFrame
	^LayoutFrame new
		leftFraction: 1 offset: (self buttonWidth * 3) negated;
		topFraction: 1 offset: self progressHeight negated;
		rightFraction: 1 offset: (self buttonWidth * 2) negated;
		bottomFraction: 1 offset: 0! !

!KoanInterface methodsFor: 'accessing' stamp: 'rms 11/7/2011 17:56'!
skippedKoans
	^ skippedKoans! !

!KoanInterface methodsFor: 'accessing' stamp: 'rms 11/7/2011 17:56'!
skippedKoans: anObject
	skippedKoans := anObject! !

!KoanInterface methodsFor: 'actions' stamp: 'esec 11/1/2011 13:06:11.574'!
updateProgress
	self result failedStep
		ifNil: [ self progress: 1 ]
		ifNotNil: [ self progress: (self result failedStep / self result totalSteps) asFloat ]! !

!KoanInterface methodsFor: 'accessing' stamp: 'wm 10/30/2013 11:33'!
welcomeMessage 
^'Hello. I''m Sensei.
Press Run to start your path to enlightenment.'.! !

Object subclass: #KoanLotus
	instanceVariableNames: 'privateInstanceVariable publicInstanceVariable'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Koans-Abouts'!

!KoanLotus methodsFor: 'accessing' stamp: 'pre 11/5/2011 11:23:03.724'!
initialize 

	self publicInstanceVariable: 'aValue'  ! !

!KoanLotus methodsFor: 'accessing' stamp: 'pre 10/16/2011 16:34:24.648'!
publicInstanceVariable
	"Answer the value of publicInstanceVariable"

	^ publicInstanceVariable! !

!KoanLotus methodsFor: 'accessing' stamp: 'pre 10/16/2011 16:34:24.654'!
publicInstanceVariable: anObject
	"Set the value of publicInstanceVariable"

	publicInstanceVariable := anObject! !

Object subclass: #KoanMetaBonsai
	instanceVariableNames: 'height'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Koans-Bonsai'!

!KoanMetaBonsai methodsFor: 'as yet unclassified' stamp: 'pre 12/9/2011 14:25:27.459'!
fruit1

	^'fruit 1'! !

!KoanMetaBonsai methodsFor: 'as yet unclassified' stamp: 'pre 12/9/2011 14:25:31.091'!
fruit2

	^'fruit 2'! !

!KoanMetaBonsai methodsFor: 'as yet unclassified' stamp: 'pre 12/9/2011 14:25:36.448'!
fruit3

	^'fruit 3'! !

!KoanMetaBonsai methodsFor: 'as yet unclassified' stamp: 'pre 12/9/2011 14:25:39.713'!
fruit4

	^'fruit 4'! !

Object subclass: #KoanPath
	instanceVariableNames: 'stream previousResult'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Koans-Core'!

!KoanPath class methodsFor: 'instance creation' stamp: 'esec 10/12/2011 13:59:54.111'!
on: aStream
	^ (self new)
		stream: aStream;
		yourself! !

!KoanPath class methodsFor: 'instance creation' stamp: 'rms 11/7/2011 18:00'!
on: aStream ignoring: aCollection
	^ (self new)
		stream: aStream;
		yourself! !

!KoanPath methodsFor: 'accessing' stamp: 'rms 12/9/2011 14:43'!
cases
	^ KoanCase allSubclasses
		sorted: [ :first :second | first priority <= second priority or: 
					[ first priority = second priority and: 
						[ first name <= second name ] ] ]! !

!KoanPath methodsFor: 'accessing' stamp: 'esec 10/21/2011 17:57:43.428'!
previousResult
	^ previousResult! !

!KoanPath methodsFor: 'accessing' stamp: 'esec 10/21/2011 17:57:43.471'!
previousResult: anObject
	previousResult := anObject! !

!KoanPath methodsFor: 'walking' stamp: 'rms 12/9/2011 14:50'!
runSensei: sensei on: steps
	| currentCase |
	
	sensei previousResult: self previousResult.
	[ steps doWithIndex: [ :step :index | 
		currentCase := step case.
		sensei observe: [ step meditate ] step: index ] ]
		on: KoanCaseFailedException do: [  ].
	
	^currentCase ! !

!KoanPath methodsFor: 'walking' stamp: 'rms 12/9/2011 14:47'!
setInitialResultFor: steps
	self previousResult: (KoanResult failed: nil method: nil attempts: 1 totalSteps: steps size)! !

!KoanPath methodsFor: 'accessing' stamp: 'rms 12/9/2011 14:57'!
stepsWithout: aCollection
	| steps |
	steps := self cases
		inject: OrderedCollection new
		into: [ :collection :next | 
			(aCollection includes: next priority) ifFalse:[
			collection
				addAll: (next allTestSelectors collect: 
							[ :selector | KoanStep on: next selector: selector ])
				 ]. collection].
	^ steps! !

!KoanPath methodsFor: 'accessing' stamp: 'esec 10/12/2011 14:00:39.717'!
stream
	^ stream! !

!KoanPath methodsFor: 'accessing' stamp: 'esec 10/12/2011 14:00:39.75'!
stream: anObject
	stream := anObject! !

!KoanPath methodsFor: 'walking' stamp: 'rms 12/9/2011 14:51'!
walkWhileIgnoring: aCollection  
	| sensei steps currentCase |
	sensei := KoanSensei on: self stream.
	steps := self stepsWithout: aCollection.
	
	self previousResult ifNil: [ self setInitialResultFor: steps ]. 
	
	currentCase := self runSensei: sensei on: steps.
		
	sensei result ifNil:[^nil].
	sensei processingFinished.
	^ sensei result currentCase: currentCase  ! !

Object subclass: #KoanResult
	instanceVariableNames: 'failedStep failedMethod attempts totalSteps currentCase'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Koans-Core'!

!KoanResult class methodsFor: 'instance creation' stamp: 'esec 11/1/2011 14:21:28.464'!
failed: aFailedStepNumber method: aFailedMethod attempts: anAttemptNumber totalSteps: aTotalStepsNumber
	^ (self new)
		failedStep: aFailedStepNumber;
		failedMethod: aFailedMethod;
		attempts: anAttemptNumber;
		totalSteps: aTotalStepsNumber;
		yourself! !

!KoanResult class methodsFor: 'instance creation' stamp: 'esec 11/1/2011 14:21:03.786'!
newFrom: anOldResult failed: aFailedStepNumber method: aFailedMethod
	| attempts |
	(anOldResult failedStep = aFailedStepNumber or: [anOldResult failedStep isNil])
		ifTrue: [ attempts := anOldResult attempts + 1 ]
		ifFalse: [ attempts := 0 ].
	^ self
		failed: aFailedStepNumber
		method: aFailedMethod
		attempts: attempts
		totalSteps: anOldResult totalSteps! !

!KoanResult methodsFor: 'accessing' stamp: 'esec 11/1/2011 11:27:16.839'!
attempts
	^ attempts! !

!KoanResult methodsFor: 'accessing' stamp: 'esec 11/1/2011 11:27:16.856'!
attempts: anObject
	attempts := anObject! !

!KoanResult methodsFor: 'accessing' stamp: 'rms 11/7/2011 18:24'!
currentCase
	^ currentCase! !

!KoanResult methodsFor: 'accessing' stamp: 'rms 11/7/2011 18:24'!
currentCase: anObject
	currentCase := anObject! !

!KoanResult methodsFor: 'accessing' stamp: 'esec 11/1/2011 14:20:07.041'!
failedMethod
	^ failedMethod! !

!KoanResult methodsFor: 'accessing' stamp: 'esec 11/1/2011 14:20:07.056'!
failedMethod: anObject
	failedMethod := anObject! !

!KoanResult methodsFor: 'accessing' stamp: 'esec 11/1/2011 11:29:16.418'!
failedStep
	^ failedStep! !

!KoanResult methodsFor: 'accessing' stamp: 'esec 11/1/2011 11:29:16.429'!
failedStep: anObject
	failedStep := anObject! !

!KoanResult methodsFor: 'accessing' stamp: 'esec 11/1/2011 11:31:34.332'!
totalSteps
	^ totalSteps! !

!KoanResult methodsFor: 'accessing' stamp: 'esec 11/1/2011 11:31:34.352'!
totalSteps: anObject
	totalSteps := anObject! !

Object subclass: #KoanSensei
	instanceVariableNames: 'stream result previousResult'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Koans-Core'!

!KoanSensei class methodsFor: 'instance creation' stamp: 'esec 10/12/2011 14:00:21.775'!
on: aStream
	^ (self new)
		stream: aStream;
		yourself! !

!KoanSensei methodsFor: 'observing' stamp: 'topa 10/14/2015 13:38'!
contextFor: aTestResult
	^ aTestResult firstException signalerContext
		findContextSuchThat: [ :ctx |
			ctx method methodHome ~~ TestCase and:
				[ctx method methodHome inheritsFrom: TestCase] ]! !

!KoanSensei methodsFor: 'observing' stamp: 'esec 10/12/2011 13:35:11.187'!
debuggerMapFor: aContext
	^ aContext method debuggerMap! !

!KoanSensei methodsFor: 'printing' stamp: 'wm 10/30/2013 11:42'!
encourage
	| encouragement cr tab |
	tab := '        '.
	cr := String crlf.
	
	(self result attempts == 0) ifTrue: [encouragement := 'You are progressing. Excellent.'].
	(self result attempts > 0) ifTrue: [encouragement := 'Do not lose hope.'].
	(self result attempts > 5) ifTrue: [encouragement := 'I sense frustration. Do not be afraid to ask for help.'].     
	
	(self stream)
		nextPutAll: (Text newFrom:'The master says:') allBold;
		nextPutAll: cr;
		nextPutAll: tab, 'You have not yet reached enlightenment.',cr;
		nextPutAll: tab, encouragement ,cr;
		nextPutAll: tab, 'Press Browse to find your path to wisdom', cr;
		nextPutAll: cr.! !

!KoanSensei methodsFor: 'observing' stamp: 'rms 12/9/2011 14:34'!
errorsInResult: evalResult
	^evalResult isNil or: [ evalResult errorCount > 0 ] or: [ evalResult failureCount > 0 ]
		! !

!KoanSensei methodsFor: 'observing' stamp: 'rms 12/9/2011 14:25'!
evaluate: aBlock
	^ aBlock value! !

!KoanSensei methodsFor: 'observing' stamp: 'topa 10/14/2015 13:39'!
handleFailedCase: aTestResult step: anIndex
	| context debuggerMap |

	context := self contextFor: aTestResult.
	debuggerMap := self debuggerMapFor: context.
	
	self
		result: (KoanResult newFrom: self previousResult 
						     failed: anIndex 
						     method: context method methodReference);
		printFailedObservation: context;
		encourage;
		printFailedCaseMessage: aTestResult firstException
			source: debuggerMap sourceText
			range: (self rangeOf: context in: debuggerMap)
			method: context method methodClass name , '>>' , context method selector! !

!KoanSensei methodsFor: 'observing' stamp: 'esec 11/1/2011 16:45:15.825'!
handleSucceededCase: aTestResult
	| test |
	test := aTestResult tests first.
	self printSucceededObservation: test! !

!KoanSensei methodsFor: 'observing' stamp: 'rms 12/9/2011 15:07'!
handleSucceededCase: evalResult step: anIndex  
			
	(self previousResult failedStep isNil 
		or: [ self previousResult failedStep <= anIndex ])
			ifTrue: [ self handleSucceededCase: evalResult ].
					
	self result: (KoanResult newFrom: self previousResult 
			                        failed: nil 
			                        method: nil).! !

!KoanSensei methodsFor: 'initialize-release' stamp: 'rms 11/7/2011 18:25'!
initialize
	super initialize.! !

!KoanSensei methodsFor: 'text-line-accessing' stamp: 'esec 10/12/2011 13:51:24.724'!
line: aLineNumber in: aString
	| splitted |
	splitted := aString splitBy: Character cr asString.
	(splitted size >= aLineNumber and: [ aLineNumber > 0 ])
		ifTrue: [ ^ splitted at: aLineNumber ]
		ifFalse: [ ^ nil ]! !

!KoanSensei methodsFor: 'text-line-accessing' stamp: 'esec 10/12/2011 13:51:46.348'!
lineCount: aString
	| splitted |
	splitted := aString splitBy: Character cr asString.
	^ splitted size! !

!KoanSensei methodsFor: 'text-line-accessing' stamp: 'esec 10/12/2011 13:50:23.371'!
lineNumberForRange: aRange in: aString
	| before splitted |
	before := aString copyFrom: 1 to: aRange first - 1.
	splitted := before splitBy: Character cr asString.
	^ splitted size! !

!KoanSensei methodsFor: 'observing' stamp: 'rms 12/9/2011 15:08'!
observe: aBlock step: anIndex
	| evalResult |
	evalResult := self evaluate: aBlock.
	(self errorsInResult: evalResult)
		ifTrue: [ 
			evalResult ifNotNil: 
				[self handleFailedCase: evalResult step: anIndex].
			KoanCaseFailedException signal ]
		ifFalse: [ self handleSucceededCase: evalResult step: anIndex. ].! !

!KoanSensei methodsFor: 'accessing' stamp: 'esec 11/1/2011 11:58:33.587'!
previousResult
	^ previousResult! !

!KoanSensei methodsFor: 'accessing' stamp: 'esec 11/1/2011 11:58:51.605'!
previousResult: anObject
	previousResult := anObject! !

!KoanSensei methodsFor: 'printing' stamp: 'rms 12/9/2011 14:20'!
printCodeLine: lineNumber ofSource: source
	| tab cr |
	tab := '        '.
	cr := String crlf.
	(self lineCount: source) >= (lineNumber + 1)
		ifTrue: [ stream nextPutAll: tab, (lineNumber + 1) asString , ' | ' , (self line: lineNumber + 1 in: source) , cr ].! !

!KoanSensei methodsFor: 'printing' stamp: 'rms 12/9/2011 14:21'!
printFailedCaseMessage: aSignal source: source range: range method: aMethodString
	| lineNumber cr tab |
	tab := '        '.
	lineNumber := self lineNumberForRange: range in: source.
	cr := String crlf.

	stream
		nextPutAll: (Text newFrom: 'Please meditate on the following code:' ) allBold  , cr;
		nextPutAll: tab,'Error type: ' , aSignal className , cr;
		nextPutAll: tab,'Error message: ' , aSignal messageText , ' at:' , cr, cr;
		nextPutAll: tab, aMethodString , ' line ' , lineNumber , cr;
		nextPutAll: tab, (lineNumber - 1) asString , ' | ' , (self line: lineNumber - 1 in: source) , cr;
		nextPutAll: (Text string: tab, lineNumber asString , ' | ' , (self line: lineNumber in: source) attribute: TextColor red) , cr.
		
	self printCodeLine: lineNumber ofSource: source.
		
	(stream respondsTo: #endEntry)
		ifTrue: [ stream endEntry ]! !

!KoanSensei methodsFor: 'printing' stamp: 'rms 11/7/2011 19:36'!
printFailedObservation: aContext
	| class cr |
	cr := String crlf.
	class := aContext method methodClassAssociation value asString.
	
	(self stream)
		nextPutAll: (Text 
		                          string: '"', class , '"' , ' has damaged your karma.' , cr  
						  attribute: (TextColor color: Color red darker)) allBold;
		nextPutAll: cr! !

!KoanSensei methodsFor: 'printing' stamp: 'esec 11/1/2011 12:53:29.253'!
printSucceededObservation: aTestName
	| cr |
	cr := String crlf.
	(self stream)
		nextPutAll:
				(Text
						string: '"' , aTestName , '"' , ' has expanded your awareness.' , cr
						attribute: (TextColor color: Color green muchDarker)) allBold;
		nextPutAll: cr! !

!KoanSensei methodsFor: 'accessing' stamp: 'esec 11/1/2011 12:58:49.357'!
processingFinished
	self result failedStep
		ifNil: [ self stream nextPutAll: (Text
			string: 'Mountains are again merely mountains.'
			attribute: (TextColor color: Color green muchDarker)) allBold ]! !

!KoanSensei methodsFor: 'observing' stamp: 'esec 10/12/2011 13:37:54.092'!
rangeOf: aContext in: aDebuggerMap
	^ aDebuggerMap rangeForPC: aContext pc contextIsActiveContext: false! !

!KoanSensei methodsFor: 'accessing' stamp: 'esec 11/1/2011 11:48:09.928'!
result
	^ result! !

!KoanSensei methodsFor: 'accessing' stamp: 'esec 11/1/2011 11:58:33.558'!
result: anObject
	result := anObject! !

!KoanSensei methodsFor: 'accessing' stamp: 'esec 10/12/2011 14:00:56.479'!
stream
	^ stream! !

!KoanSensei methodsFor: 'accessing' stamp: 'esec 10/12/2011 14:00:56.527'!
stream: anObject
	stream := anObject! !

Object subclass: #KoanStep
	instanceVariableNames: 'case selector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Koans-Core'!

!KoanStep class methodsFor: 'instance creation' stamp: 'esec 10/10/2011 17:28'!
on: aKoanCase selector: aSymbol
	^ (self new)
		case: aKoanCase;
		selector: aSymbol;
		yourself! !

!KoanStep methodsFor: 'accessing' stamp: 'esec 10/10/2011 17:28'!
case
	^ case! !

!KoanStep methodsFor: 'accessing' stamp: 'esec 10/10/2011 17:28'!
case: anObject
	case := anObject! !

!KoanStep methodsFor: 'meditating' stamp: 'esec 10/11/2011 15:34'!
createTestSuite
	| suite |
	suite := TestSuite named: 'koan-testsuite-' , self identityHash asString.
	suite addTest: (self case selector: selector).
	^ suite! !

!KoanStep methodsFor: 'meditating' stamp: 'topa 10/14/2015 13:31'!
meditate
	| testResult testSuite |
	testSuite := self createTestSuite.
	testResult := KoanTestResult new.
	testSuite run: testResult.
	^ testResult! !

!KoanStep methodsFor: 'accessing' stamp: 'esec 10/10/2011 17:28'!
selector
	^ selector! !

!KoanStep methodsFor: 'accessing' stamp: 'esec 10/10/2011 17:28'!
selector: anObject
	selector := anObject! !

Object subclass: #Koans
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Koans-Core'!

!Koans class methodsFor: 'running' stamp: 'pre 12/9/2011 14:47:57.168'!
initialize

	"self initialize"
	TheWorldMenu registerOpenCommand: {'Koans'. {self. #open}}  ! !

!Koans class methodsFor: 'running' stamp: 'esec 10/10/2011 16:02'!
open
	ToolBuilder open: KoanInterface new! !
Koans initialize!
